TidyPlatesThreat = LibStub("AceAddon-3.0"):NewAddon("TidyPlatesThreat", "AceConsole-3.0","AceEvent-3.0")
local Media = LibStub("LibSharedMedia-3.0")
local DataBroker = LibStub:GetLibrary("LibDataBroker-1.1",true)
local path = "Interface\\Addons\\TidyPlates_ThreatPlates\\Artwork\\"

--[[Set MultiStyle]]--
if not TidyPlatesThemeList then TidyPlatesThemeList = {} end
TidyPlatesThemeList["ThreatPlates"] = {}

--[[Options and Default Settings]]--
function TidyPlatesThreat:OnInitialize()
	local options = { 
		type = "group", 
		args = {
			OptionsDescription = {
				type = "description",
				order = 1,
				name = "Clear and easy to use nameplate theme for use with TidyPlates.\nFeel free to email me at |cff00ff00Shamtasticle@gmail.com|r\nSyronius, of Black Dragonflight - US <Fallout>",
			},
--[[Options Frames]]--
			OptionsHeader = {
				order = 2,
				type = "header",
				name = "Tidy Plates: Threat Plates v1.6a",
			},
			TextOptFrame = {
		        order = 1,
		        type  = "group",
       			name  = "Text Options",
		        args = {
					TextOptHeader = {
						order = 1,
						type = "header",
						name = "Text Options",
					},
					hptextdesc = {
						order = 2,
						type = "description",
						name = "\nHP Special Text is the center text displaying the truncated HP amount and HP percentage on nameplates.\n",
					},
					hptext = {
						order = 3,
						type = "toggle",
						name = "Show HP Special Text",
						desc = "Toggles the showing and hiding of HP Special Text",
						get = function() return self.db.profile.hptext end,
						set = function(info,val) 
							self.db.profile.hptext = not self.db.profile.hptext
							if self.db.profile.hptext then return print("-->>HP Special Text is now |cff00ff00ON!|r<<--") else return print("-->>HP Special Text is now |cffff0000OFF!|r<<--") end
						end
					},
					casttext = {
						order = 5,
						type = "toggle",
						name = "Show Spell Cast Text",
						desc = "Toggles the showing and hiding of Spell Cast Text",
						get = function() return self.db.profile.casttext end,
						set = function(info,val) 
							self.db.profile.casttext = not self.db.profile.casttext
							if self.db.profile.casttext then return print("-->>Spell Cast Text is now |cff00ff00ON!|r<<--") else return print("-->>Spell Cast Text is now |cffff0000OFF!|r<<--") end
						end
					},
				},
			},
			ThreatOptFrame = {
		        order = 4,
		        type  = "group",
       			name  = "Threat Options",
		        args = {
					ThreatDescription = {
						type = "description",
						order = 1,
						name = "Toggle the threat system on or off",
					},
					threat = {
						order = 2,
						type = "toggle",
						name = "Enable Threat System",
						desc = "Enable or disable the threat plates system.",
						get = function() return self.db.profile.threat end,
						set = function(info,val) 
							self.db.profile.threat = not self.db.profile.threat
							if self.db.profile.threat then return print("-->>|cff00ff00Threat System is now ON!|r<<--") else return print("-->>|cffff0000Threat System is now OFF!|r<<--") end
						end
					},
					RoleDescription = {
						type = "description",
						order = 3,
						name = "Select which role you're currently fulfilling.",
					},
					DPSRole = {
						order = 4,
						type = "toggle",
						name = "DPS Role",
						desc = "Enable or disable the threat plates system for DPSing.",
						get = function() return not self.db.profile.role end,
						set = function(info,val) 
								self.db.profile.role = false
								self.db.profile.threat = true
								self.db.profile.textrole = "dps"
								print("-->>|cff00ff00DPS Role threat system is now active!!|r<<--")
							end
					},
					TankRole = {
						order = 4,
						type = "toggle",
						name = "Tank Role",
						desc = "Enable or disable the threat plates system for Tanking.",
						get = function() return self.db.profile.role end,
						set = function(info,val) 
								self.db.profile.role = true
								self.db.profile.threat = true
								self.db.profile.textrole = "tank"
								print("-->>|cff00ff00Tank Role threat system is now active!!|r<<--")
							end
					},
					DPS = {
						name = "|cffffffffDPS Threat Levels|r",
						type = "group",
						desc = "Set threat scales for DPSing",
						order = 1,
						args = {
							dpsdesc = {
								type = "description",
								order = 1,
								name = "Set the scale levels for each level of threat.",
							},
							lowthreat = {
								type 	= "range",
								order 	= 2,
								name 	= "|cff00ff00Low Threat Scale|r",
								get 	= function(info) return self.db.profile.dpslowscale end,
								set 	= function(info,v)
											self.db.profile.dpslowscale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							medthreat = {
								type 	= "range",
								order 	= 3,
								name 	= "|cffffff00Medium Threat Scale|r",
								get 	= function(info) return self.db.profile.dpsmedscale end,
								set 	= function(info,v)
											self.db.profile.dpsmedscale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							highthreat = {
								type 	= "range",
								order 	= 4,
								name 	= "|cffff0000High Threat Scale|r",
								get 	= function(info) return self.db.profile.dpshighscale end,
								set 	= function(info,v)
											self.db.profile.dpshighscale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
						},
					},
					Tank = {
						name = "|cffffffffTank Threat Levels|r",
						type = "group",
						desc = "Set threat scales for Tanking",
						order = 2,
						args = {
							tankdesc = {
								type = "description",
								order = 1,
								name = "Set the scale levels for each level of threat.",
							},
							lowthreat = {
								type 	= "range",
								order 	= 2,
								name 	= "|cffff0000Low Threat Scale|r",
								get 	= function(info) return self.db.profile.tanklowscale end,
								set 	= function(info,v)
											self.db.profile.tanklowscale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							medthreat = {
								type 	= "range",
								order 	= 3,
								name 	= "|cffffff00Medium Threat Scale|r",
								get 	= function(info) return self.db.profile.tankmedscale end,
								set 	= function(info,v)
											self.db.profile.tankmedscale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
							highthreat = {
								type 	= "range",
								order 	= 4,
								name 	= "|cff00ff00High Threat Scale|r",
								get 	= function(info) return self.db.profile.tankhighscale end,
								set 	= function(info,v)
											self.db.profile.tankhighscale = v
										end,								
								step = 0.05,
								min = 0.3,
								max = 2,
								isPercent = true,
							},
						},
					},
				},
			},
		},
	}
	local defaults 	= {
		profile = {
			hptext				= true,
			role 				= true,
			threat 				= true,
			textrole 			= "tank",
			tanklowscale		= 1.25,
			tankmedscale		= 0.90,
			tankhighscale		= 0.70,
			dpshighscale		= 1.25,
			dpsmedscale			= 0.90,
			dpslowscale			= 0.70,
		}
    }
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Tidy Plates: Threat Plates Options:", options)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Tidy Plates: Threat Plates Options:", "Tidy Plates: Threat Plates")
	self:RegisterChatCommand("tptp", function () InterfaceOptionsFrame_OpenToCategory(self.optionsFrame) end)
	self.message = ""
	self.db = LibStub("AceDB-3.0"):New("ThreatPlatesDB", defaults)
	local db = self.db.profile
	--[[
	Media.RegisterCallback(self, "LibSharedMedia_Registered", "UpdateMedia")
	Media.RegisterCallback(self, "LibSharedMedia_SetGlobal", "UpdateMedia")
	]]--
end

--[[Unutilized UpdateMedia]]--

--[[function TidyPlatesThreat:UpdateMedia(callback, type, handle)
	if type == "statusbar" then
		self.heal_bars:SetTexture(Media:Fetch("statusbar", self.db.profile.texture))
		self.cast_bars:SetTexture(Media:Fetch("statusbar", self.db.profile.texture2))
	end
end
]]--
--[[TPTP Tank Toggle Command]]--
local function TPTPTANK()
	TidyPlatesThreat.db.profile.role = true
	TidyPlatesThreat.db.profile.textrole = "tank"
	print("-->>|cff00ff00Tank Plates Enabled|r<<--")
end
SLASH_TPTPTANK1 = "/tptptank"
SlashCmdList["TPTPTANK"] = TPTPTANK

--[[TPTP DPS Toggle Command]]--
local function TPTPDPS()
	TidyPlatesThreat.db.profile.role = false
	TidyPlatesThreat.db.profile.textrole = "dps"
	print("-->>|cffff0000DPS Plates Enabled|r<<--")
end
SLASH_TPTPDPS1 = "/tptpdps"
SlashCmdList["TPTPDPS"] = TPTPDPS

--[[TPTP Role Toggle Command]]--

local function TPTPTOGGLE()
	TidyPlatesThreat.db.profile.role = not TidyPlatesThreat.db.profile.role
	if TidyPlatesThreat.db.profile.role then 
		TidyPlatesThreat.db.profile.textrole = "tank"
		return print("-->>|cff00ff00Tank Plates Enabled|r<<--")
	else
		TidyPlatesThreat.db.profile.textrole = "dps"
		return print("-->>|cffff0000DPS Plates Enabled|r<<--")
	end
end
SLASH_TPTPTOGGLE1 = "/tptptoggle"
SlashCmdList["TPTPTOGGLE"] = TPTPTOGGLE


function SetSpecialArt(unit)
	if TidyPlatesThreat.db.profile.threat and unit.reaction == "HOSTILE" and InCombatLockdown() then
		return path..TidyPlatesThreat.db.profile.textrole.."\\"..unit.threatSituation
	else
		return nil
	end
end

local Truncate = function(value)
	if value >= 1e6 then
		return format('%.1fm', value / 1e6)
	elseif value >= 1e4 then
		return format('%.1fk', value / 1e3)
	else
		return value
	end
end

function SetSpecialText(unit)
	if TidyPlatesThreat.db.profile.hptext then
		healthpercent = 100* (unit.health / unit.healthmax) 				--[[Creates the health percentage number]]--
		if (unit.health / unit.healthmax) < 1 then 							--[[If Health is less than 100%]]--
			return Truncate(unit.health).." - "..ceil(healthpercent ).."%" 	--[[Display Truncated HP Amount and Percentage]]--
		else 																--[[If HP is 100%]]--
			return --[[ceil(healthpercent ).."%"]]--								--[[Display Nothing or Optional 100% text]]--
		end
	end
end

function SetSpecialText2(unit)
	if TidyPlatesThreat.db.profile.casttext then
		local spellname
		if unit.isCasting then 
			spellname = UnitCastingInfo("target") 
			if spellname == nil then
				spellname = UnitChannelInfo("target")
			end
			return spellname
		else return ""
		end
	end
end

local function SetStyle(unit)
	if InCombatLockdown() and unit.reaction == "HOSTILE" and TidyPlatesThreat.db.profile.threat then
		if TidyPlatesThreat.db.profile.role then
			return "tank"
		else
			return "dps"
		end
	else 
		return "normal" 
	end
end

local function SetScale(unit)
	if TidyPlatesThreat.db.profile.threat and InCombatLockdown() then
		if unit.threatSituation == "LOW" then
			if TidyPlatesThreat.db.profile.role then
				return TidyPlatesThreat.db.profile.tanklowscale
			else 
				return TidyPlatesThreat.db.profile.dpslowscale
			end
		elseif unit.threatSituation == "MEDIUM" then
			if TidyPlatesThreat.db.profile.role then
				return TidyPlatesThreat.db.profile.tankmedscale
			else 
				return TidyPlatesThreat.db.profile.dpsmedscale
			end
		elseif unit.threatSituation == "HIGH" then
		if TidyPlatesThreat.db.profile.role then
				return TidyPlatesThreat.db.profile.tankhighscale
			else 
				return TidyPlatesThreat.db.profile.dpshighscale
			end
		end
	else 
		return 1
	end
end

TidyPlatesThemeList["ThreatPlates"].SetStyle = SetStyle
TidyPlatesThemeList["ThreatPlates"].SetScale = SetScale
TidyPlatesThemeList["ThreatPlates"].SetSpecialText = SetSpecialText
TidyPlatesThemeList["ThreatPlates"].SetSpecialText2 = SetSpecialText2
TidyPlatesThemeList["ThreatPlates"].SetSpecialArt = SetSpecialArt

--[[Auto Settings]]--

SetCVar("threatWarning", 3)
SetCVar("nameplateShowEnemies", 1)
SetCVar("ShowClassColorInNameplate", 1)